'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _layout = require('../antd/layout');

var _layout2 = _interopRequireDefault(_layout);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function generator(props) {
  return function (Basic) {
    return function (_React$Component) {
      _inherits(Adapter, _React$Component);

      function Adapter() {
        _classCallCheck(this, Adapter);

        return _possibleConstructorReturn(this, (Adapter.__proto__ || Object.getPrototypeOf(Adapter)).apply(this, arguments));
      }

      _createClass(Adapter, [{
        key: 'render',
        value: function render() {
          var prefixCls = props.prefixCls;

          return _react2.default.createElement(Basic, _extends({ prefixCls: prefixCls }, this.props));
        }
      }]);

      return Adapter;
    }(_react2.default.Component);
  };
}

var Basic = function (_React$Component2) {
  _inherits(Basic, _React$Component2);

  function Basic() {
    _classCallCheck(this, Basic);

    return _possibleConstructorReturn(this, (Basic.__proto__ || Object.getPrototypeOf(Basic)).apply(this, arguments));
  }

  _createClass(Basic, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          prefixCls = _props.prefixCls,
          className = _props.className,
          children = _props.children,
          others = _objectWithoutProperties(_props, ['prefixCls', 'className', 'children']);

      var hasSider = void 0;
      _react2.default.Children.forEach(children, function (element) {
        if (element && element.type && element.type.__FLUX_LAYOUT_SIDER) {
          hasSider = true;
        }
      });
      var divCls = (className ? className : '') + ' ' + prefixCls + (hasSider ? ' ' + prefixCls + '-has-sider' : '');
      return _react2.default.createElement(
        'div',
        _extends({ className: divCls }, others),
        children
      );
    }
  }]);

  return Basic;
}(_react2.default.Component);

var Layout = generator({
  prefixCls: 'flux-layout'
})(Basic);

var Header = generator({
  prefixCls: 'flux-layout-header'
})(Basic);

var Footer = generator({
  prefixCls: 'flux-layout-footer'
})(Basic);

var Content = generator({
  prefixCls: 'flux-layout-content'
})(Basic);

var Sider = function Sider(props) {
  return _react2.default.createElement(_layout2.default.Sider, _extends({ prefixCls: 'flux-layout-sider' }, props));
};
Sider.__FLUX_LAYOUT_SIDER = true;

Layout.Header = Header;
Layout.Footer = Footer;
Layout.Content = Content;
Layout.Sider = Sider;

exports.default = Layout;