'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _list = require('./list');

var _list2 = _interopRequireDefault(_list);

var _operation = require('./operation');

var _operation2 = _interopRequireDefault(_operation);

var _search = require('./search');

var _search2 = _interopRequireDefault(_search);

var _injectLocale = require('../locale-provider/injectLocale');

var _injectLocale2 = _interopRequireDefault(_injectLocale);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function noop() {}

var Transfer = function (_React$Component) {
  _inherits(Transfer, _React$Component);

  // For high-level customized Transfer @dqaria
  function Transfer(props) {
    _classCallCheck(this, Transfer);

    var _this = _possibleConstructorReturn(this, (Transfer.__proto__ || Object.getPrototypeOf(Transfer)).call(this, props));

    _initialiseProps.call(_this);

    var _props$selectedKeys = props.selectedKeys,
        selectedKeys = _props$selectedKeys === undefined ? [] : _props$selectedKeys,
        _props$targetKeys = props.targetKeys,
        targetKeys = _props$targetKeys === undefined ? [] : _props$targetKeys;

    _this.state = {
      leftFilter: '',
      rightFilter: '',
      sourceSelectedKeys: selectedKeys.filter(function (key) {
        return targetKeys.indexOf(key) === -1;
      }),
      targetSelectedKeys: selectedKeys.filter(function (key) {
        return targetKeys.indexOf(key) > -1;
      })
    };
    return _this;
  }

  _createClass(Transfer, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _state = this.state,
          sourceSelectedKeys = _state.sourceSelectedKeys,
          targetSelectedKeys = _state.targetSelectedKeys;

      if (nextProps.targetKeys !== this.props.targetKeys || nextProps.dataSource !== this.props.dataSource) {
        // clear cached splited dataSource
        this.splitedDataSource = null;
        if (!nextProps.selectedKeys) {
          // clear key nolonger existed
          // clear checkedKeys according to targetKeys
          var dataSource = nextProps.dataSource,
              _nextProps$targetKeys = nextProps.targetKeys,
              targetKeys = _nextProps$targetKeys === undefined ? [] : _nextProps$targetKeys;

          var newSourceSelectedKeys = [];
          var newTargetSelectedKeys = [];
          dataSource.forEach(function (record) {
            if (sourceSelectedKeys.includes(record.key) && !targetKeys.includes(record.key)) {
              newSourceSelectedKeys.push(record.key);
            }
            if (targetSelectedKeys.includes(record.key) && targetKeys.includes(record.key)) {
              newTargetSelectedKeys.push(record.key);
            }
          });
          this.setState({
            sourceSelectedKeys: newSourceSelectedKeys,
            targetSelectedKeys: newTargetSelectedKeys
          });
        }
      }

      if (nextProps.selectedKeys) {
        var _targetKeys = nextProps.targetKeys;
        this.setState({
          sourceSelectedKeys: nextProps.selectedKeys.filter(function (key) {
            return _targetKeys.indexOf(key) === -1;
          }),
          targetSelectedKeys: nextProps.selectedKeys.filter(function (key) {
            return _targetKeys.indexOf(key) > -1;
          })
        });
      }
    }
  }, {
    key: 'splitDataSource',
    value: function splitDataSource(props) {
      if (this.splitedDataSource) return this.splitedDataSource;
      var rowKey = props.rowKey,
          dataSource = props.dataSource,
          _props$targetKeys2 = props.targetKeys,
          targetKeys = _props$targetKeys2 === undefined ? [] : _props$targetKeys2;

      var leftDataSource = [];
      var rightDataSource = [];
      dataSource.forEach(function (record) {
        if (rowKey) record.key = rowKey(record);
        if (targetKeys.includes(record.key)) rightDataSource.push(record);else leftDataSource.push(record);
      });

      this.splitedDataSource = { leftDataSource: leftDataSource, rightDataSource: rightDataSource };
      return this.splitedDataSource;
    }
  }, {
    key: 'handleSelectChange',
    value: function handleSelectChange(direction, holder) {
      var _state2 = this.state,
          sourceSelectedKeys = _state2.sourceSelectedKeys,
          targetSelectedKeys = _state2.targetSelectedKeys;

      var onSelectChange = this.props.onSelectChange;
      if (!onSelectChange) {
        return;
      }

      if (direction === 'left') {
        onSelectChange(holder, targetSelectedKeys);
      } else {
        onSelectChange(sourceSelectedKeys, holder);
      }
    }
  }, {
    key: 'getTitles',
    value: function getTitles() {
      var props = this.props;

      if (props.titles) return props.titles;
      var transferLocale = this.getLocale();
      return transferLocale.titles;
    }
  }, {
    key: 'getSelectedKeysName',
    value: function getSelectedKeysName(direction) {
      return direction === 'left' ? 'sourceSelectedKeys' : 'targetSelectedKeys';
    }
  }, {
    key: 'render',
    value: function render() {
      var locale = this.getLocale();
      var _props = this.props,
          _props$prefixCls = _props.prefixCls,
          prefixCls = _props$prefixCls === undefined ? 'flux-transfer' : _props$prefixCls,
          className = _props.className,
          _props$operations = _props.operations,
          operations = _props$operations === undefined ? [] : _props$operations,
          showSearch = _props.showSearch,
          _props$notFoundConten = _props.notFoundContent,
          notFoundContent = _props$notFoundConten === undefined ? locale.notFoundContent : _props$notFoundConten,
          _props$searchPlacehol = _props.searchPlaceholder,
          searchPlaceholder = _props$searchPlacehol === undefined ? locale.searchPlaceholder : _props$searchPlacehol,
          body = _props.body,
          footer = _props.footer,
          listStyle = _props.listStyle,
          filterOption = _props.filterOption,
          render = _props.render,
          lazy = _props.lazy;
      var _state3 = this.state,
          leftFilter = _state3.leftFilter,
          rightFilter = _state3.rightFilter,
          sourceSelectedKeys = _state3.sourceSelectedKeys,
          targetSelectedKeys = _state3.targetSelectedKeys;

      var _splitDataSource = this.splitDataSource(this.props),
          leftDataSource = _splitDataSource.leftDataSource,
          rightDataSource = _splitDataSource.rightDataSource;

      var leftActive = targetSelectedKeys.length > 0;
      var rightActive = sourceSelectedKeys.length > 0;
      var cls = (0, _classnames2.default)(className, prefixCls);
      var titles = this.getTitles();
      return _react2.default.createElement(
        'div',
        { className: cls },
        _react2.default.createElement(_list2.default, {
          prefixCls: prefixCls + '-list',
          titleText: titles[0],
          dataSource: leftDataSource,
          filter: leftFilter,
          filterOption: filterOption,
          style: listStyle,
          checkedKeys: sourceSelectedKeys,
          handleFilter: this.handleLeftFilter,
          handleClear: this.handleLeftClear,
          handleSelect: this.handleLeftSelect,
          handleSelectAll: this.handleLeftSelectAll,
          render: render,
          showSearch: showSearch,
          searchPlaceholder: searchPlaceholder,
          notFoundContent: notFoundContent,
          itemUnit: locale.itemUnit,
          itemsUnit: locale.itemsUnit,
          body: body,
          footer: footer,
          lazy: lazy,
          onScroll: this.handleLeftScroll
        }),
        _react2.default.createElement(_operation2.default, {
          className: prefixCls + '-operation',
          rightActive: rightActive,
          rightArrowText: operations[0],
          moveToRight: this.moveToRight,
          leftActive: leftActive,
          leftArrowText: operations[1],
          moveToLeft: this.moveToLeft
        }),
        _react2.default.createElement(_list2.default, {
          prefixCls: prefixCls + '-list',
          titleText: titles[1],
          dataSource: rightDataSource,
          filter: rightFilter,
          filterOption: filterOption,
          style: listStyle,
          checkedKeys: targetSelectedKeys,
          handleFilter: this.handleRightFilter,
          handleClear: this.handleRightClear,
          handleSelect: this.handleRightSelect,
          handleSelectAll: this.handleRightSelectAll,
          render: render,
          showSearch: showSearch,
          searchPlaceholder: searchPlaceholder,
          notFoundContent: notFoundContent,
          itemUnit: locale.itemUnit,
          itemsUnit: locale.itemsUnit,
          body: body,
          footer: footer,
          lazy: lazy,
          onScroll: this.handleRightScroll
        })
      );
    }
  }]);

  return Transfer;
}(_react2.default.Component);

Transfer.List = _list2.default;
Transfer.Operation = _operation2.default;
Transfer.Search = _search2.default;
Transfer.defaultProps = {
  dataSource: [],
  render: noop,
  showSearch: false
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.moveTo = function (direction) {
    var _props2 = _this2.props,
        _props2$targetKeys = _props2.targetKeys,
        targetKeys = _props2$targetKeys === undefined ? [] : _props2$targetKeys,
        _props2$dataSource = _props2.dataSource,
        dataSource = _props2$dataSource === undefined ? [] : _props2$dataSource,
        onChange = _props2.onChange;
    var _state4 = _this2.state,
        sourceSelectedKeys = _state4.sourceSelectedKeys,
        targetSelectedKeys = _state4.targetSelectedKeys;

    var moveKeys = direction === 'right' ? sourceSelectedKeys : targetSelectedKeys;
    // filter the disabled options
    var newMoveKeys = moveKeys.filter(function (key) {
      return !dataSource.some(function (data) {
        return !!(key === data.key && data.disabled);
      });
    });
    // move items to target box
    var newTargetKeys = direction === 'right' ? newMoveKeys.concat(targetKeys) : targetKeys.filter(function (targetKey) {
      return newMoveKeys.indexOf(targetKey) === -1;
    });

    // empty checked keys
    var oppositeDirection = direction === 'right' ? 'left' : 'right';
    _this2.setState(_defineProperty({}, _this2.getSelectedKeysName(oppositeDirection), []));
    _this2.handleSelectChange(oppositeDirection, []);

    if (onChange) {
      onChange(newTargetKeys, direction, newMoveKeys);
    }
  };

  this.moveToLeft = function () {
    return _this2.moveTo('left');
  };

  this.moveToRight = function () {
    return _this2.moveTo('right');
  };

  this.handleSelectAll = function (direction, filteredDataSource, checkAll) {
    var originalSelectedKeys = _this2.state[_this2.getSelectedKeysName(direction)] || [];
    var currentKeys = filteredDataSource.map(function (item) {
      return item.key;
    });
    // Only operate current keys from original selected keys
    var newKeys1 = originalSelectedKeys.filter(function (key) {
      return currentKeys.indexOf(key) === -1;
    });
    var newKeys2 = [].concat(_toConsumableArray(originalSelectedKeys));
    currentKeys.forEach(function (key) {
      if (newKeys2.indexOf(key) === -1) {
        newKeys2.push(key);
      }
    });
    var holder = checkAll ? newKeys1 : newKeys2;
    _this2.handleSelectChange(direction, holder);

    if (!_this2.props.selectedKeys) {
      _this2.setState(_defineProperty({}, _this2.getSelectedKeysName(direction), holder));
    }
  };

  this.handleLeftSelectAll = function (filteredDataSource, checkAll) {
    return _this2.handleSelectAll('left', filteredDataSource, checkAll);
  };

  this.handleRightSelectAll = function (filteredDataSource, checkAll) {
    return _this2.handleSelectAll('right', filteredDataSource, checkAll);
  };

  this.handleFilter = function (direction, e) {
    _this2.setState(_defineProperty({}, direction + 'Filter', e.target.value));
    if (_this2.props.onSearchChange) {
      _this2.props.onSearchChange(direction, e);
    }
  };

  this.handleLeftFilter = function (e) {
    return _this2.handleFilter('left', e);
  };

  this.handleRightFilter = function (e) {
    return _this2.handleFilter('right', e);
  };

  this.handleClear = function (direction) {
    _this2.setState(_defineProperty({}, direction + 'Filter', ''));
  };

  this.handleLeftClear = function () {
    return _this2.handleClear('left');
  };

  this.handleRightClear = function () {
    return _this2.handleClear('right');
  };

  this.handleSelect = function (direction, selectedItem, checked) {
    var _state5 = _this2.state,
        sourceSelectedKeys = _state5.sourceSelectedKeys,
        targetSelectedKeys = _state5.targetSelectedKeys;

    var holder = direction === 'left' ? [].concat(_toConsumableArray(sourceSelectedKeys)) : [].concat(_toConsumableArray(targetSelectedKeys));
    var index = holder.indexOf(selectedItem.key);
    if (index > -1) {
      holder.splice(index, 1);
    }
    if (checked) {
      holder.push(selectedItem.key);
    }
    _this2.handleSelectChange(direction, holder);

    if (!_this2.props.selectedKeys) {
      _this2.setState(_defineProperty({}, _this2.getSelectedKeysName(direction), holder));
    }
  };

  this.handleLeftSelect = function (selectedItem, checked) {
    return _this2.handleSelect('left', selectedItem, checked);
  };

  this.handleRightSelect = function (selectedItem, checked) {
    return _this2.handleSelect('right', selectedItem, checked);
  };

  this.handleScroll = function (direction, e) {
    var onScroll = _this2.props.onScroll;

    if (onScroll) {
      onScroll(direction, e);
    }
  };

  this.handleLeftScroll = function (e) {
    return _this2.handleScroll('left', e);
  };

  this.handleRightScroll = function (e) {
    return _this2.handleScroll('right', e);
  };
};

var injectTransferLocale = (0, _injectLocale2.default)('Transfer', {
  titles: ['', ''],
  searchPlaceholder: 'Search',
  notFoundContent: 'Not Found'
});

exports.default = injectTransferLocale(Transfer);
// export default Transfer